using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Microsoft.HomeServer.Extensibility;
using Microsoft.HomeServer.Controls;
using Microsoft.HomeServer.Common.Client;

namespace Microsoft.HomeServer.HomeServerConsoleTab.WHSControlsExample2CS
{
    public partial class MainTabUserControl : UserControl
    {
        IConsoleServices consoleServices;

        public MainTabUserControl()
        {
            InitializeComponent();
        }

        public MainTabUserControl(int width, int height, IConsoleServices consoleServices)
            : this()
        {
            this.Width = width;
            this.Height = height;
            this.consoleServices = consoleServices;
        }

        private void addNewConsoleToolBarButton_Click(object sender, EventArgs e)
        {
            //Two options exist for adding a new ConsoleToolBarButton...
            //using the default constructor or not:

            //Using default constructor:
            //Create button and explicitly set text and event handlers
            //Not unlike what happens when created with the designer
            ConsoleToolBarButton newButton = new ConsoleToolBarButton();
            newButton.Text = "New Button";
            newButton.MouseEnter += new EventHandler(consoleToolBarButtons_MouseEnter);
            newButton.MouseLeave += new EventHandler(consoleToolBarButtons_MouseLeave);

            ////Using non default constructor:
            ////Create button and specify name and automatically get color changing with mouse enter/leave
            //ConsoleToolBarButton newButton = new ConsoleToolBarButton("New Button");

            //Add event handler to remove button when clicked
            newButton.Click += new EventHandler(newButton_Click);

            //Add new button to ConsoleToolBar
            consoleToolBar1.Items.Add(newButton);
        }

        private void consoleToolBarButtons_MouseEnter(object sender, EventArgs e)
        {
            //Determine which ConsoleToolBarButton raised event
            ConsoleToolBarButton button = sender as ConsoleToolBarButton;

            //Set color
            button.ForeColor = Color.Black;
        }

        private void consoleToolBarButtons_MouseLeave(object sender, EventArgs e)
        {
            //Determine which ConsoleToolBarButton raised event
            ConsoleToolBarButton button = sender as ConsoleToolBarButton;

            //Set color
            button.ForeColor = Color.White;
        }

        void newButton_Click(object sender, EventArgs e)
        {
            //Determine which ConsoleToolBarButton raised event
            ConsoleToolBarButton button = sender as ConsoleToolBarButton;

            //Remove button
            consoleToolBar1.Items.Remove(button);
        }

        private void MainTabUserControl_Load(object sender, EventArgs e)
        {
            //Add header text to first LineBox
            lineBox1.Header.Text = "LineBox1";

            //Add header text to first LineBox
            lineBox2.Header.Text = "LineBox2";
            //Change color and font as well
            lineBox2.Header.ForeColor = Color.HotPink;
            lineBox2.Header.Font = new Font("Comic Sans MS", 14);


            //Add Images to four of the QButtons:
            redIconButton.Image = CommonImages.RedIcon;
            //Note the sizing issue we see with an image that is too large for the area
            yellowIconButton.Image = CommonImages.YellowIcon;
            greenIconButton.Image = CommonImages.GreenIcon;
            grayIconButton.Image = CommonImages.GrayIcon;
        }
    }
}
